unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, GameOfLife;

type

  { TForm1 }

  TForm1 = class(TForm)
    btNext: TButton;
    btStart: TButton;
    btReset: TButton;
    btClear: TButton;
    tfGeneration: TEdit;
    Label1: TLabel;
    panelGame: TPanel;
    panelButtons: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure reset();
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1;
  mModel: TGameOfLife;
  mPanels: Array of Array of TPanel;

implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
    mModel:= TGameOfLife.Create;
    tfGeneration.Text:= IntToStr(mModel.getGeneration);

    mModel.reset(5,5);
    self.reset();

end;

procedure TForm1.FormPaint(Sender: TObject);
var
    tmp: Array of Array of Boolean;
begin
    tmp:= mModel.getArray();


end;

procedure TForm1.FormResize(Sender: TObject);
var
    y, x, startY, startX, _height, _width, _left, _top: Integer;
begin
    _height:= ((panelGame.Height - 2) div (High(mPanels) + 1)) - 2;
    _width:= ((panelGame.Width - 2) div (High(mPanels[0]) + 1)) - 2;
    _left:= (panelGame.Width + 2 - ((High(mPanels[0]) + 1) * (_width + 2))) div 2;
    _top:= (panelGame.Height + 2 - ((High(mPanels) + 1) * (_height + 2))) div 2;

    writeln(IntToStr(_height) + ' ' + IntToStr(_width) + ' ' + IntToStr(_left) + ' ' + IntToStr(_top));

    startY:= _top;

    for y:= 0 to High(mPanels) do
    begin
        startX:= _left;

        write('Top: ' + IntToStr(startY) + ', Left: ');

        for x:= 0 to High(mPanels[y]) do
        begin
            mPanels[y][x].SetBounds(startX,startY,_width,_height);

            write(' ' + IntToStr(startX));

            startX:= startX + _width + 2;
        end;

        writeln;

        startY:= startY + _height + 2;
    end;
end;

procedure TForm1.reset();
var
    startY, startX, _height, _width, _left, _top, count, _y, _x: Integer;
    tmp: Array of Array of Boolean;
begin
    while panelGame.ComponentCount > 0 do
    begin
        panelGame.Components[0].free;
    end;

    tmp:= mModel.getArray();

    SetLength(mPanels,High(tmp) + 1);

    _height:= ((panelGame.Height - 2) div (High(tmp) + 1)) - 2;
    _width:= ((panelGame.Width - 2) div (High(tmp[0]) + 1)) - 2;
    _left:= (panelGame.Width + 2 - ((High(tmp[0]) + 1) * (_width + 2))) div 2;
    _top:= (panelGame.Height + 2 - ((High(tmp) + 1) * (_height + 2))) div 2;

    count:= 0;
    startY:= _top;

    for _y:= 0 to High(tmp) do
    begin
        SetLength(mPanels[_y],High(tmp[_y]) + 1);
        startX:= _left;

        for _x:= 0 to High(tmp[_y]) do
        begin
            mPanels[_y][_x]:= TPanel.Create(panelGame);
            mPanels[_y][_x].Parent:= panelGame;
            mPanels[_y][_x].SetBounds(startX,startY,_width,_height);
            mPanels[_y][_x].Visible:= True;
            mPanels[_y][_x].Enabled:= True;

            startX:= startX + _width + 2;
        end;

        startY:= startY + _height + 2;
    end;
end;

initialization
  {$I unit1.lrs}

end.

